import type { DCloneHTMLElement, DId, DSize } from '../../utils/types';
import type { DFormControl } from '../form';
import React from 'react';
export interface DSelectRef {
    updatePosition: () => void;
}
export interface DSelectItem<V extends DId> {
    label: string;
    value: V;
    disabled?: boolean;
    children?: DSelectItem<V>[];
}
export interface DSelectProps<V extends DId, T extends DSelectItem<V>> extends Omit<React.HTMLAttributes<HTMLDivElement>, 'children'> {
    dRef?: {
        input?: React.ForwardedRef<HTMLInputElement>;
    };
    dFormControl?: DFormControl;
    dList: T[];
    dModel?: V | null | V[];
    dVisible?: boolean;
    dPlaceholder?: string;
    dSize?: DSize;
    dLoading?: boolean;
    dSearchable?: boolean;
    dSearchValue?: string;
    dClearable?: boolean;
    dDisabled?: boolean;
    dMultiple?: boolean;
    dCustomItem?: (item: T) => React.ReactNode;
    dCustomSelected?: (select: T) => string;
    dCustomSearch?: {
        filter?: (value: string, item: T) => boolean;
        sort?: (a: T, b: T) => number;
    };
    dCreateItem?: (value: string) => T | undefined;
    dPopupClassName?: string;
    dInputRender?: DCloneHTMLElement<React.InputHTMLAttributes<HTMLInputElement>>;
    onModelChange?: (value: any, item: any) => void;
    onVisibleChange?: (visible: boolean) => void;
    onSearchValueChange?: (value: string) => void;
    onClear?: () => void;
    onCreateItem?: (item: T) => void;
    onScrollBottom?: () => void;
    afterVisibleChange?: (visible: boolean) => void;
}
declare function Select<V extends DId, T extends DSelectItem<V>>(props: DSelectProps<V, T>, ref: React.ForwardedRef<DSelectRef>): JSX.Element | null;
export declare const DSelect: <V extends DId, T extends DSelectItem<V>>(props: DSelectProps<V, T> & React.RefAttributes<DSelectRef>) => ReturnType<typeof Select>;
export {};
