var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { isArray, isNull, isNumber, isUndefined, toNumber } from 'lodash';
import { useEffect, useState, useRef } from 'react';
import { useEvent, useRefExtra } from '@react-devui/hooks';
import { getClassName } from '@react-devui/utils';
import { useGeneralContext, useDValue } from '../../hooks';
import { registerComponentMate } from '../../utils';
import { DBaseInput } from '../_base-input';
import { useFormControl } from '../form';
import { useComponentConfig, usePrefixConfig } from '../root';
import { DTooltip } from '../tooltip';
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DSlider' });
export function DSlider(props) {
    var _a, _b;
    const _c = useComponentConfig(COMPONENT_NAME, props), { dRef, dFormControl, dModel, dMax = 100, dMin = 0, dStep = 1, dDisabled = false, dMarks, dVertical = false, dReverse = false, dRange = false, dRangeMinDistance, dRangeThumbDraggable = false, dTooltipVisible, dCustomTooltip, dInputRender, onModelChange } = _c, restProps = __rest(_c, ["dRef", "dFormControl", "dModel", "dMax", "dMin", "dStep", "dDisabled", "dMarks", "dVertical", "dReverse", "dRange", "dRangeMinDistance", "dRangeThumbDraggable", "dTooltipVisible", "dCustomTooltip", "dInputRender", "onModelChange"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    const { gDisabled } = useGeneralContext();
    //#endregion
    //#region Ref
    const sliderRef = useRef(null);
    const dotLeftRef = useRef(null);
    const dotRightRef = useRef(null);
    const tooltipLeftRef = useRef(null);
    const tooltipRightRef = useRef(null);
    const windowRef = useRefExtra(() => window);
    //#endregion
    const [focusDot, setFocusDot] = useState(null);
    const [mouseenterDot, setMouseenterDot] = useState(null);
    const [draggableDot, setDraggableDot] = useState(null);
    const [thumbPoint, setThumbPoint] = useState(null);
    const formControlInject = useFormControl(dFormControl);
    const [_value, changeValue] = useDValue(dRange ? [0, 0] : 0, dModel, onModelChange, (a, b) => {
        if (isNumber(a) && isNumber(b)) {
            return a === b;
        }
        else if (isArray(a) && isArray(b)) {
            return a[0] === b[0] && a[1] === b[1];
        }
        return false;
    }, formControlInject);
    const [valueLeft, valueRight = 0] = (dRange ? _value : [_value]);
    const disabled = dDisabled || gDisabled || (dFormControl === null || dFormControl === void 0 ? void 0 : dFormControl.control.disabled);
    const [visibleLeft, visibleRight] = [
        (_a = (dRange ? dTooltipVisible === null || dTooltipVisible === void 0 ? void 0 : dTooltipVisible[0] : dTooltipVisible)) !== null && _a !== void 0 ? _a : (mouseenterDot === 'left' ? true : !!(focusDot === 'left' || thumbPoint)),
        (_b = (dRange ? dTooltipVisible === null || dTooltipVisible === void 0 ? void 0 : dTooltipVisible[1] : undefined)) !== null && _b !== void 0 ? _b : (mouseenterDot === 'right' ? true : !!(focusDot === 'right' || thumbPoint)),
    ];
    const preventBlur = (e) => {
        if (e.button === 0) {
            e.preventDefault();
        }
    };
    const getValue = (value, func = 'round') => {
        let newValue = null;
        if (dStep) {
            const n = Math[func](value / dStep);
            newValue = Math.min(dMax, Math.max(dMin, n * dStep));
        }
        if (isArray(dMarks)) {
            let min = newValue ? Math.abs(newValue - value) : Infinity;
            if (min > 0) {
                for (const mark of dMarks) {
                    const v = isNumber(mark) ? mark : mark.value;
                    if (func === 'round' || (func === 'ceil' && v - value >= 0) || (func === 'floor' && v - value <= 0)) {
                        const offset = Math.abs(v - value);
                        if (offset < min) {
                            min = offset;
                            newValue = v;
                        }
                    }
                }
            }
        }
        return newValue !== null && newValue !== void 0 ? newValue : dMin;
    };
    const handleMove = (e, isLeft) => {
        isLeft = isLeft !== null && isLeft !== void 0 ? isLeft : focusDot === 'left';
        if (sliderRef.current) {
            const rect = sliderRef.current.getBoundingClientRect();
            const newValue = getValue((dMax - dMin) *
                (dVertical
                    ? (dReverse ? e.clientY - rect.top : rect.bottom - e.clientY) / rect.height
                    : (dReverse ? rect.right - e.clientX : e.clientX - rect.left) / rect.width));
            if (dRange) {
                changeValue((draft) => {
                    const index = isLeft ? 0 : 1;
                    if (draft[index] !== newValue) {
                        const offset = newValue - draft[index];
                        const isAdd = offset > 0;
                        draft[index] = newValue;
                        if (isNumber(dRangeMinDistance) && draft[1] - draft[0] < dRangeMinDistance) {
                            const _index = isLeft ? 1 : 0;
                            draft[_index] = getValue(draft[_index] + offset, isAdd ? 'ceil' : 'floor');
                            if (draft[1] - draft[0] < dRangeMinDistance) {
                                draft[index] = getValue(draft[_index] + (isAdd ? -dRangeMinDistance : dRangeMinDistance), isAdd ? 'floor' : 'ceil');
                            }
                        }
                    }
                });
            }
            else {
                changeValue(newValue);
            }
        }
    };
    const handleThumbMove = (e) => {
        if (dStep && thumbPoint && sliderRef.current) {
            const rect = sliderRef.current.getBoundingClientRect();
            const offset = Math.round(((dMax - dMin) *
                (dVertical
                    ? (dReverse ? e.clientY - thumbPoint.clientY : thumbPoint.clientY - e.clientY) / rect.height
                    : (dReverse ? thumbPoint.clientX - e.clientX : e.clientX - thumbPoint.clientX) / rect.width)) /
                dStep) * dStep;
            const value = [0, 0];
            let index = -1;
            for (const v of [thumbPoint.left + offset, thumbPoint.right + offset]) {
                index += 1;
                const _index = index === 0 ? 1 : 0;
                if (v < dMin) {
                    value[index] = dMin;
                    value[_index] = dMin + Math.abs(thumbPoint.left - thumbPoint.right);
                    break;
                }
                if (v > dMax) {
                    value[index] = dMax;
                    value[_index] = dMax - Math.abs(thumbPoint.left - thumbPoint.right);
                    break;
                }
                value[index] = v;
            }
            changeValue(value);
        }
    };
    const startDrag = (e) => {
        const handle = (isLeft = true) => {
            const el = isLeft ? dotLeftRef.current : dotRightRef.current;
            if (el) {
                handleMove(e, isLeft);
                setDraggableDot(isLeft ? 'left' : 'right');
                el.firstElementChild.focus({ preventScroll: true });
            }
        };
        if (dRange) {
            if (dotLeftRef.current && dotRightRef.current) {
                const rectLeft = dotLeftRef.current.getBoundingClientRect();
                const rectRight = dotRightRef.current.getBoundingClientRect();
                const offsetLeft = dVertical
                    ? Math.abs(rectLeft.bottom - rectLeft.height / 2 - e.clientY)
                    : Math.abs(e.clientX - (rectLeft.left + rectLeft.width / 2));
                const offsetRight = dVertical
                    ? Math.abs(rectRight.bottom - rectRight.height / 2 - e.clientY)
                    : Math.abs(e.clientX - (rectRight.left + rectRight.width / 2));
                if (dRangeThumbDraggable &&
                    (dVertical ? e.clientY < Math.max(rectLeft.top, rectRight.top) : e.clientX > Math.min(rectLeft.right, rectRight.right)) &&
                    (dVertical ? e.clientY > Math.min(rectLeft.bottom, rectRight.bottom) : e.clientX < Math.max(rectLeft.left, rectRight.left))) {
                    setThumbPoint({ left: valueLeft, right: valueRight, clientX: e.clientX, clientY: e.clientY });
                }
                else {
                    if (offsetRight <= offsetLeft) {
                        handle(false);
                    }
                    else {
                        handle(true);
                    }
                }
            }
        }
        else {
            handle(true);
        }
    };
    useEffect(() => {
        var _a, _b, _c, _d;
        if (thumbPoint) {
            (_a = tooltipLeftRef.current) === null || _a === void 0 ? void 0 : _a.updatePosition();
            (_b = tooltipRightRef.current) === null || _b === void 0 ? void 0 : _b.updatePosition();
        }
        else {
            if (focusDot === 'left') {
                (_c = tooltipLeftRef.current) === null || _c === void 0 ? void 0 : _c.updatePosition();
            }
            else if (focusDot === 'right') {
                (_d = tooltipRightRef.current) === null || _d === void 0 ? void 0 : _d.updatePosition();
            }
        }
    }, [focusDot, _value, thumbPoint]);
    const listenDragEvent = !isNull(draggableDot) || !isNull(thumbPoint);
    useEvent(windowRef, 'touchmove', (e) => {
        if (!isNull(draggableDot)) {
            e.preventDefault();
            handleMove({ clientX: e.touches[0].clientX, clientY: e.touches[0].clientY });
        }
        if (!isNull(thumbPoint)) {
            e.preventDefault();
            handleThumbMove({ clientX: e.touches[0].clientX, clientY: e.touches[0].clientY });
        }
    }, { passive: false }, !listenDragEvent);
    useEvent(windowRef, 'mousemove', (e) => {
        if (!isNull(draggableDot)) {
            e.preventDefault();
            handleMove({ clientX: e.clientX, clientY: e.clientY });
        }
        if (!isNull(thumbPoint)) {
            e.preventDefault();
            handleThumbMove({ clientX: e.clientX, clientY: e.clientY });
        }
    }, {}, !listenDragEvent);
    useEvent(windowRef, 'mouseup', () => {
        setDraggableDot(null);
        setThumbPoint(null);
    }, {}, !listenDragEvent);
    const marks = (() => {
        const marks = [];
        const getNode = (value, label = null) => {
            let percentage = (value / (dMax - dMin)) * 100;
            if (dReverse) {
                percentage = 100 - percentage;
            }
            marks.push(_jsx("div", Object.assign({ className: getClassName(`${dPrefix}slider__mark`, {
                    [`${dPrefix}slider__mark--hidden`]: value === dMin || value === dMax,
                }), style: {
                    left: dVertical ? undefined : `${percentage}%`,
                    bottom: dVertical ? `${percentage}%` : undefined,
                } }, { children: label && (_jsx("div", Object.assign({ className: getClassName(`${dPrefix}slider__mark-label`, {
                        'is-active': dRange
                            ? value <= Math.max(valueLeft, valueRight) && value >= Math.min(valueLeft, valueRight)
                            : value <= valueLeft,
                    }) }, { children: label }), value)) }), value));
        };
        if (isArray(dMarks)) {
            dMarks.forEach((mark) => {
                const value = isNumber(mark) ? mark : mark.value;
                getNode(value, isNumber(mark) ? null : mark.label);
            });
        }
        else if (isNumber(dMarks)) {
            for (let index = 0; index < (dMax - dMin) / dMarks; index++) {
                const value = index * dMarks;
                getNode(value);
            }
        }
        return marks;
    })();
    const getDotNode = (isLeft) => {
        const value = isLeft ? valueLeft : valueRight;
        return (_jsx(DTooltip, Object.assign({ ref: isLeft ? tooltipLeftRef : tooltipRightRef, dVisible: isLeft ? visibleLeft : visibleRight, dTitle: dCustomTooltip ? dCustomTooltip(value) : value, dPlacement: dVertical ? 'right' : 'top', onVisibleChange: (visible) => {
                setMouseenterDot(visible ? (isLeft ? 'left' : 'right') : null);
            } }, { children: _jsx("div", Object.assign({ ref: isLeft ? dotLeftRef : dotRightRef, className: getClassName(`${dPrefix}slider__input-wrapper`, {
                    'is-focus': focusDot === (isLeft ? 'left' : 'right'),
                }), style: {
                    left: dVertical ? undefined : `calc(${value} / ${dMax - dMin} * 100% - 7px)`,
                    bottom: dVertical ? `calc(${value} / ${dMax - dMin} * 100% - 7px)` : undefined,
                } }, { children: _jsx(DBaseInput, Object.assign({ dFormControl: dFormControl, dLabelFor: isLeft }, { children: ({ render: renderBaseInput }) => {
                        const inputRender = (dInputRender !== null && dInputRender !== void 0 ? dInputRender : [])[isLeft ? 0 : 1];
                        const input = renderBaseInput(_jsx("input", { ref: isLeft ? dRef === null || dRef === void 0 ? void 0 : dRef.inputLeft : dRef === null || dRef === void 0 ? void 0 : dRef.inputRight, className: `${dPrefix}slider__input`, type: "range", value: value, disabled: disabled, max: dMax, min: dMin, step: dStep !== null && dStep !== void 0 ? dStep : undefined, "aria-orientation": dVertical ? 'vertical' : 'horizontal', onChange: (e) => {
                                const val = toNumber(e.currentTarget.value);
                                if (dRange) {
                                    const index = isLeft ? 0 : 1;
                                    changeValue((draft) => {
                                        const offset = val - draft[index];
                                        const isAdd = offset > 0;
                                        draft[index] = val;
                                        if (isNumber(dRangeMinDistance) && draft[1] - draft[0] < dRangeMinDistance) {
                                            const _index = isLeft ? 1 : 0;
                                            draft[_index] = getValue(draft[_index] + offset, isAdd ? 'ceil' : 'floor');
                                            if (draft[1] - draft[0] < dRangeMinDistance) {
                                                draft[index] = getValue(draft[_index] + (isAdd ? -dRangeMinDistance : dRangeMinDistance), isAdd ? 'floor' : 'ceil');
                                            }
                                        }
                                    });
                                }
                                else {
                                    changeValue(val);
                                }
                            }, onFocus: () => {
                                setFocusDot(isLeft ? 'left' : 'right');
                            }, onBlur: () => {
                                setFocusDot(null);
                            } }));
                        return isUndefined(inputRender) ? input : inputRender(input);
                    } })) })) })));
    };
    return (_jsxs("div", Object.assign({}, restProps, { ref: sliderRef, className: getClassName(restProps.className, `${dPrefix}slider`, `${dPrefix}slider--${dVertical ? 'vertical' : 'horizontal'}`, {
            'is-disabled': disabled,
        }), onMouseDown: (e) => {
            var _a;
            (_a = restProps.onMouseDown) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
            preventBlur(e);
            if (e.button === 0) {
                startDrag(e);
            }
        }, onMouseUp: (e) => {
            var _a;
            (_a = restProps.onMouseUp) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
            preventBlur(e);
        }, onTouchStart: (e) => {
            var _a;
            (_a = restProps.onTouchStart) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
            startDrag({ clientX: e.touches[0].clientX, clientY: e.touches[0].clientY });
        }, onTouchEnd: (e) => {
            var _a;
            (_a = restProps.onTouchEnd) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
            setDraggableDot(null);
            setThumbPoint(null);
        } }, { children: [_jsxs("div", Object.assign({ className: getClassName(`${dPrefix}slider__thumb`, {
                    [`${dPrefix}slider__thumb--reverse `]: dReverse,
                }) }, { children: [_jsx("div", { className: getClassName(`${dPrefix}slider__active-thumb`, {
                            [`${dPrefix}slider__active-thumb--draggable`]: dRangeThumbDraggable,
                            'is-focus': thumbPoint,
                        }), style: dVertical
                            ? {
                                bottom: `calc(${Math.min(valueLeft, valueRight)} / ${dMax - dMin} * 100%)`,
                                top: `calc(${dMax - Math.max(valueLeft, valueRight)} / ${dMax - dMin} * 100%)`,
                            }
                            : {
                                left: `calc(${Math.min(valueLeft, valueRight)} / ${dMax - dMin} * 100%)`,
                                right: `calc(${dMax - Math.max(valueLeft, valueRight)} / ${dMax - dMin} * 100%)`,
                            } }), getDotNode(true), dRange && getDotNode(false)] })), marks] })));
}
